Unit MsgLog;

interface

//Uses
//  SysUtils;

Type

  DWORD = LongWord;
  HWND  = type LongWord;
  {$EXTERNALSYM HWND}
  UINT = LongWord;
  {$EXTERNALSYM UINT}
  WPARAM = Longint;
  {$EXTERNALSYM WPARAM}
  LPARAM = Longint;
  {$EXTERNALSYM LPARAM}
  LRESULT = Longint;
  {$EXTERNALSYM LRESULT}

  { lParam of WM_COPYDATA message points to... }
  PCopyDataStruct = ^TCopyDataStruct;
  {$EXTERNALSYM tagCOPYDATASTRUCT}
  tagCOPYDATASTRUCT = packed record
    dwData: DWORD;
    cbData: DWORD;
    lpData: Pointer;
  end;
  TCopyDataStruct = tagCOPYDATASTRUCT;
  {$EXTERNALSYM COPYDATASTRUCT}
  COPYDATASTRUCT = tagCOPYDATASTRUCT;

const
  {$IFDEF MSWINDOWS}
  kernel32  = 'kernel32.dll';
  user32    = 'user32.dll';
  {$EXTERNALSYM WM_USER}
  WM_USER             = $0400;
  {$EXTERNALSYM WM_COPYDATA}
  WM_COPYDATA         = $004A;

{$EXTERNALSYM FindWindow}
function FindWindow(lpClassName, lpWindowName: PChar): HWND; stdcall;
{$EXTERNALSYM SendMessage}
function SendMessage(hWnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
{$EXTERNALSYM GetCurrentProcessId}
function GetCurrentProcessId: DWORD; stdcall;
procedure SendDebugMsg(DebugMsg: String);
function StrLen(const Str: PChar): Cardinal;

implementation

function FindWindow; external user32 name 'FindWindowA';    
function SendMessage; external user32 name 'SendMessageA';
{$ENDIF}
function GetCurrentProcessId; external kernel32 name 'GetCurrentProcessId';

{----------------------- StrLen() From SysUtils.pas ---------------------------}
function StrLen(const Str: PChar): Cardinal; assembler;
asm
        MOV     EDX,EDI
        MOV     EDI,EAX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        MOV     EAX,0FFFFFFFEH
        SUB     EAX,ECX
        MOV     EDI,EDX
end;

{---------------------------- SendDebugMsg ------------------------------------}
procedure SendDebugMsg(DebugMsg: String);
var
  WND      : HWND;
  CopyData : TCopyDataStruct;
begin
  WND:=FindWindow(PChar('TMsgLoger'),Nil);
  if WND <> 0 then begin
    With CopyData do begin
      dwData := 0;
      cbData := StrLen(PChar(DebugMsg));
      lpData := PChar(DebugMsg);
    end;
    SendMessage(WND,WM_COPYDATA,GetCurrentProcessId,Integer(@CopyData));
  end;
end;

end.