unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, ToolWin, ActnMan, ActnCtrls, ActnMenus, XPStyleActnCtrls,
  ComCtrls, StdCtrls, ImgList, ExtCtrls, Menus, ActnPopup, ActnColorMaps,
  CustomizeDlg;

type
  TMsgLoger = class(TForm)
    ActionManager: TActionManager;
    ActionMainMenuBar: TActionMainMenuBar;
    Act_Exit: TAction;
    Act_About: TAction;
    Act_SaveFile: TAction;
    SaveDlg: TSaveDialog;
    mmInf: TMemo;
    StatusBar: TStatusBar;
    Act_Clear: TAction;
    Act_Stop: TAction;
    Act_Suspend: TAction;
    Act_Numbers: TAction;
    Act_InsrtTime: TAction;
    ImgLst: TImageList;
    Act_Trey: TAction;
    TrayIcon: TTrayIcon;
    PopupActionBar: TPopupActionBar;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    Act_TransparentColor: TAction;
    Act_OnTop: TAction;
    N6: TMenuItem;
    N7: TMenuItem;
    Act_ProcId: TAction;
    Act_ToCaption: TAction;
    Act_Splitter: TAction;
    procedure Act_SplitterExecute(Sender: TObject);
    procedure Act_ToCaptionExecute(Sender: TObject);
    procedure Act_ProcIdExecute(Sender: TObject);
    procedure Act_TransparentColorExecute(Sender: TObject);
    procedure Act_OnTopExecute(Sender: TObject);
    procedure TrayIconClick(Sender: TObject);
    procedure Act_TreyExecute(Sender: TObject);
    procedure Act_AboutExecute(Sender: TObject);
    procedure Act_SaveFileExecute(Sender: TObject);
    procedure Act_NumbersExecute(Sender: TObject);
    procedure Act_InsrtTimeExecute(Sender: TObject);
    procedure Act_SuspendExecute(Sender: TObject);
    procedure Act_StopExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Act_ClearExecute(Sender: TObject);
    procedure Act_ExitExecute(Sender: TObject);
    procedure GetWMCopyData(var Msg: TWMCopyData); message WM_COPYDATA;
  private
    { Private declarations }
    procedure ApplicationMinimize(Sender : TObject);
  public
    { Public declarations }
  end;

var
  MsgLoger: TMsgLoger;
  count: Integer = 0;
  SuspendLst: TStrings;
  Ext: array[1..3] of string = ('.txt','.log','');
  WNDTRAY  : Boolean;
  StrSplt  : String;  // 
implementation

uses Unit2;

{$R *.dfm}

procedure TMsgLoger.Act_AboutExecute(Sender: TObject);
begin
  AboutFrm.show;
end;

procedure TMsgLoger.Act_TransparentColorExecute(Sender: TObject);
begin
  if Act_TransparentColor.Checked then begin
    MsgLoger.BorderStyle           := bsNone;
    ActionMainMenuBar.Parent       :=StatusBar;
    StatusBar.Hide;
    mmInf.Font.Color               := $0000FF;
    mmInf.BorderStyle              := bsNone;
    mmInf.ScrollBars               := ssNone;
    MsgLoger.TransparentColor      := True;
    MsgLoger.TransparentColorValue := clWhite;
    TrayIcon.Visible               := true;
    ShowWindow(Application.Handle,SW_HIDE);
  end
  else begin
    MsgLoger.BorderStyle           := bsSizeable;
    ActionMainMenuBar.Parent       := MsgLoger;
    StatusBar.Show;
    mmInf.Font.Color               := clBlack;
    mmInf.BorderStyle              := bsSingle;
    mmInf.ScrollBars               := ssVertical;
    MsgLoger.TransparentColor      := False;
    MsgLoger.TransparentColorValue := clWhite;
    TrayIcon.Visible               := false;
  end;
end;

procedure TMsgLoger.Act_ClearExecute(Sender: TObject);
begin
  mmInf.Clear;
  SuspendLst.Clear;
  count:=0;
end;

procedure TMsgLoger.Act_ExitExecute(Sender: TObject);
begin
  close;
end;

procedure TMsgLoger.Act_InsrtTimeExecute(Sender: TObject);
begin
  //
end;

procedure TMsgLoger.Act_NumbersExecute(Sender: TObject);
begin
  //
end;

procedure TMsgLoger.Act_ToCaptionExecute(Sender: TObject);
begin
  //
end;

procedure TMsgLoger.Act_OnTopExecute(Sender: TObject);
begin
  if Act_OnTop.Checked then MsgLoger.FormStyle:=fsStayOnTop
  else MsgLoger.FormStyle:=fsNormal;
end;

procedure TMsgLoger.Act_ProcIdExecute(Sender: TObject);
begin
  //
end;

procedure TMsgLoger.Act_SaveFileExecute(Sender: TObject);
Var FStrm: TFileStream;
begin
  if Not SaveDlg.Execute then exit;
  if ExtractFileExt(SaveDlg.FileName) = '' then
    SaveDlg.FileName:=SaveDlg.FileName+Ext[SaveDlg.FilterIndex];
    if FileExists(SaveDlg.FileName) then
      if MessageBox(Handle,PChar(SaveDlg.FileName+'  .'+#10+' ?'),
          PChar('MSGLoger :'),MB_YESNO or MB_ICONWARNING) = 7 then Exit;
  try
    try
      FStrm:=TFileStream.Create(SaveDlg.FileName,fmCreate);
      FStrm.Write(mmInf.text[1],Length(mmInf.text));
      if Act_Suspend.Checked then
        if Length(SuspendLst.Text) <> 0 then
          FStrm.Write(SuspendLst.Text[1],Length(SuspendLst.Text));
    finally
      FStrm.Free;
    end;
  except
    RaiseLastWin32Error;
    exit;
  end;
end;

procedure TMsgLoger.Act_SplitterExecute(Sender: TObject);
begin
  //
end;

procedure TMsgLoger.Act_StopExecute(Sender: TObject);
begin
  //
end;

procedure TMsgLoger.Act_SuspendExecute(Sender: TObject);
begin
  if Not Act_Suspend.Checked then begin
    mmInf.Lines.AddStrings(SuspendLst);
    SuspendLst.Clear;
  end;
end;

procedure TMsgLoger.Act_TreyExecute(Sender: TObject);
begin
  if WNDTRAY then begin
    WNDTRAY := False;
    ShowWindow(Handle,SW_NORMAL);
    if Not Act_TransparentColor.Checked then begin
      ShowWindow(Handle,SW_NORMAL);
      TrayIcon.Visible := False;
    end;
    Act_Trey.Caption:='  ';
  end
  else begin
    WNDTRAY := true;
    ShowWindow(Application.Handle,SW_HIDE);
    ShowWindow(Handle,SW_HIDE);
    TrayIcon.Visible := true;
    Act_Trey.Caption := '';
  end;
end;

procedure TMsgLoger.ApplicationMinimize(Sender: TObject);
begin
  ShowWindow(Application.Handle, SW_HIDE);
end;

procedure TMsgLoger.FormCreate(Sender: TObject);
begin
  SuspendLst := TStringList.Create;
  //  StrSplt 
  SetLength(StrSplt,80);
  FillMemory(@StrSplt[1],80,Ord('-'));
end;

procedure TMsgLoger.GetWMCopyData(var Msg: TWMCopyData);
var
  temp     : String;
  StrCount : String;  //C 
  StrTime  : String;  //  
  ProcId   : String;  // 
  NLCode   : String;  //NewLine Code

begin
  if Act_Stop.Checked then exit;
  Inc(Count);
  SetLength(temp,Msg.CopyDataStruct.cbData);
  StrLCopy(@temp[1], Msg.CopyDataStruct.lpData, Msg.CopyDataStruct.cbData);

  if Act_Numbers.Checked then StrCount  := IntToStr(Count)+'. ';
  if Act_InsrtTime.Checked then StrTime := TimeToStr(Time)+' ';
  if Act_ProcId.Checked then ProcId := 'PID: '+IntToStr(Msg.From)+' ';
  if Act_ToCaption.Checked then NLCode:=#13#10;

  if Act_Suspend.Checked then begin
    SuspendLst.Add(NLCode+StrCount+StrTime+ProcId+NLCode+Temp);
    If Act_Splitter.Checked then SuspendLst.Add(StrSplt);
    exit;
  end;

  mmInf.Lines.Add(NLCode+StrCount+StrTime+ProcId+NLCode+Temp);
  If Act_Splitter.Checked then mmInf.Lines.Add(StrSplt);

end;

procedure TMsgLoger.TrayIconClick(Sender: TObject);
begin
  ShowWindow(Handle,SW_SHOW);
  if Act_TransparentColor.Checked then exit;
  ShowWindow(Application.Handle,SW_SHOWNORMAL);
  TrayIcon.Visible:=false;
end;

end.
